package com.citrusengine.objects.platformer {

	import Box2DAS.Dynamics.ContactEvent;

	import com.citrusengine.objects.PhysicsObject;

	import flash.utils.clearTimeout;
	import flash.utils.setTimeout;
 
 
	/**
	 * @author Aymeric
	 */
	public class Teleporter extends Sensor {
 		
		[Inspectable(defaultValue=0)]
		public var endX:Number = 0;
		
		[Inspectable(defaultValue=0)]
		public var endY:Number = 0;
		
		[Inspectable(defaultValue="",type="String")]
		public var object:PhysicsObject;
 
 		[Inspectable(defaultValue=0)]
		public var waitingTime:Number = 0;
		
		public var teleport:Boolean = false;
 
		protected var _teleporting:Boolean = false;
 
		protected var _teleportTimeoutID:uint;
 
		public function Teleporter(name:String, params:Object = null) {
			super(name, params);
		}
 
		override public function destroy():void {
 
			clearTimeout(_teleportTimeoutID);
 
			super.destroy();
		}
 
		override public function update(timeDelta:Number):void {
 
			super.update(timeDelta);
 
			if (teleport) {
 
				_teleporting = true;
 
				_teleportTimeoutID = setTimeout(_teleport, waitingTime);
 
				teleport = false;
			}
 
			_updateAnimation();
		}
		
		override protected function handleBeginContact(e:ContactEvent):void {
			onBeginContact.dispatch(e);
			teleport = true;
		}
 
		protected function _teleport():void {
 
			_teleporting = false;
 
			object.x = endX;
			object.y = endY;
 
			clearTimeout(_teleportTimeoutID);
		}
 
		protected function _updateAnimation():void {
 
			if (_teleporting) {
				_animation = "teleport";
			} else {
				_animation = "normal";
			}
		}
	}
}