﻿package com.citrusengine.objects.platformer {
 
	import Box2DAS.Dynamics.b2Body;
 
	import com.citrusengine.objects.platformer.MovingPlatform;
 
	/**
	 * @author Aymeric
	 */
	public class Treadmill extends MovingPlatform {
 
 		[Inspectable(defaultValue=3)]
		public var speedTread:Number = 3;
		
		[Inspectable(defaultValue="right",enumeration="right,left")]
		public var startingDirection:String = "right";
 
 		[Inspectable(defaultValue=true)]
		public var enableTreadmill:Boolean = true;
 
		public function Treadmill(name:String, params:Object = null) {
			
			super(name, params);
 
			if (startingDirection == "left") {
				_inverted = true;
			}
		}
 
		override public function destroy():void {
 
			super.destroy();
		}
 
		override public function update(timeDelta:Number):void {
 
			super.update(timeDelta);
 
			if (enableTreadmill) {
 
				for each (var passengers:b2Body in _passengers) {
 
					if (startingDirection == "right") {
						passengers.GetUserData().x += speedTread;
					} else {
						passengers.GetUserData().x -= speedTread;
					}
 
				}
			}
 
			_updateAnimation();
		}
 
		protected function _updateAnimation():void {
 
			if (enableTreadmill) {
				_animation = "move";
			} else {
				_animation = "normal";
			}
		}
	}
}