package {

    import Box2DAS.Collision.Shapes.b2PolygonShape;
	import Box2DAS.Common.V2;

	import com.citrusengine.objects.PhysicsObject;

	/**
	 * @author Aymeric
	 * <p>This is a class created by the software http://www.physicseditor.de/</p>
	 * <p>Just select the CitrusEngine template, upload your png picture, set polygons and export.</p>
	 * <p>Be careful, the registration point is topLeft !</p>
	 * @param peObject : the name of the png file
	 */
    public class PhysicsEditorObjects extends PhysicsObject {
		
		[Inspectable(defaultValue="")]
		public var peObject:String = "";

		private var _tab:Array;

		public function PhysicsEditorObjects(name:String, params:Object = null) {

			super(name, params);
		}

		override public function destroy():void {

			super.destroy();
		}

		override public function update(timeDelta:Number):void {

			super.update(timeDelta);
		}

		override protected function defineFixture():void {
			
			super.defineFixture();
			
			_createVertices();

			_fixtureDef.density = _getDensity();
			_fixtureDef.friction = _getFriction();
			_fixtureDef.restitution = _getRestitution();
			
			for (var i:uint = 0; i < _tab.length; ++i) {
				var polygonShape:b2PolygonShape = new b2PolygonShape();
				polygonShape.Set(_tab[i]);
				_fixtureDef.shape = polygonShape;

				body.CreateFixture(_fixtureDef);
			}
		}
		
        protected function _createVertices():void {
			
			_tab = [];
			var vertices:Vector.<V2> = new Vector.<V2>();

			switch (peObject) {
				
				case "icecream":
											
			        vertices.push(new V2(30.5/_box2D.scale, 45.5/_box2D.scale));
					vertices.push(new V2(97.5/_box2D.scale, 246.5/_box2D.scale));
					vertices.push(new V2(93.5/_box2D.scale, 270.5/_box2D.scale));
					vertices.push(new V2(62.5/_box2D.scale, 302.5/_box2D.scale));
					vertices.push(new V2(21.5/_box2D.scale, 126.5/_box2D.scale));
					vertices.push(new V2(16.5/_box2D.scale, 62.5/_box2D.scale));
					vertices.push(new V2(18.5/_box2D.scale, 50.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(62.5/_box2D.scale, 302.5/_box2D.scale));
					vertices.push(new V2(93.5/_box2D.scale, 270.5/_box2D.scale));
					vertices.push(new V2(81.5/_box2D.scale, 306.5/_box2D.scale));
					vertices.push(new V2(73.5/_box2D.scale, 312.5/_box2D.scale));
					vertices.push(new V2(65.5/_box2D.scale, 310.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(9.5/_box2D.scale, 111.5/_box2D.scale));
					vertices.push(new V2(16.5/_box2D.scale, 62.5/_box2D.scale));
					vertices.push(new V2(21.5/_box2D.scale, 126.5/_box2D.scale));
					vertices.push(new V2(10.5/_box2D.scale, 121.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(44.5/_box2D.scale, 32.5/_box2D.scale));
					vertices.push(new V2(135.5/_box2D.scale, 65.5/_box2D.scale));
					vertices.push(new V2(144.5/_box2D.scale, 115.5/_box2D.scale));
					vertices.push(new V2(135.5/_box2D.scale, 120.5/_box2D.scale));
					vertices.push(new V2(30.5/_box2D.scale, 45.5/_box2D.scale));
					vertices.push(new V2(28.5/_box2D.scale, 37.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(0.5/_box2D.scale, 81.5/_box2D.scale));
					vertices.push(new V2(6.5/_box2D.scale, 69.5/_box2D.scale));
					vertices.push(new V2(16.5/_box2D.scale, 62.5/_box2D.scale));
					vertices.push(new V2(9.5/_box2D.scale, 111.5/_box2D.scale));
					vertices.push(new V2(-0.5/_box2D.scale, 97.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(82.5/_box2D.scale, 3.5/_box2D.scale));
					vertices.push(new V2(127.5/_box2D.scale, 42.5/_box2D.scale));
					vertices.push(new V2(135.5/_box2D.scale, 65.5/_box2D.scale));
					vertices.push(new V2(44.5/_box2D.scale, 32.5/_box2D.scale));
					vertices.push(new V2(51.5/_box2D.scale, 14.5/_box2D.scale));
					vertices.push(new V2(70.5/_box2D.scale, -0.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(151.5/_box2D.scale, 86.5/_box2D.scale));
					vertices.push(new V2(144.5/_box2D.scale, 115.5/_box2D.scale));
					vertices.push(new V2(135.5/_box2D.scale, 65.5/_box2D.scale));
					vertices.push(new V2(146.5/_box2D.scale, 73.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(129.5/_box2D.scale, 129.5/_box2D.scale));
					vertices.push(new V2(30.5/_box2D.scale, 45.5/_box2D.scale));
					vertices.push(new V2(135.5/_box2D.scale, 120.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(101.5/_box2D.scale, 241.5/_box2D.scale));
					vertices.push(new V2(97.5/_box2D.scale, 246.5/_box2D.scale));
					vertices.push(new V2(30.5/_box2D.scale, 45.5/_box2D.scale));
					vertices.push(new V2(129.5/_box2D.scale, 129.5/_box2D.scale));
					
					_tab.push(vertices);
					
					break;
			
				case "muffin":
											
			        vertices.push(new V2(195.5/_box2D.scale, 166.5/_box2D.scale));
					vertices.push(new V2(188.5/_box2D.scale, 128.5/_box2D.scale));
					vertices.push(new V2(199.5/_box2D.scale, 158.5/_box2D.scale));
					vertices.push(new V2(199.5/_box2D.scale, 164.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(89.5/_box2D.scale, -0.5/_box2D.scale));
					vertices.push(new V2(95.5/_box2D.scale, 8.5/_box2D.scale));
					vertices.push(new V2(92.5/_box2D.scale, 14.5/_box2D.scale));
					vertices.push(new V2(82.5/_box2D.scale, 3.5/_box2D.scale));
					vertices.push(new V2(85.5/_box2D.scale, -0.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(2.5/_box2D.scale, 149.5/_box2D.scale));
					vertices.push(new V2(23.5/_box2D.scale, 117.5/_box2D.scale));
					vertices.push(new V2(9.5/_box2D.scale, 175.5/_box2D.scale));
					vertices.push(new V2(-0.5/_box2D.scale, 161.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(120.5/_box2D.scale, 71.5/_box2D.scale));
					vertices.push(new V2(120.5/_box2D.scale, 91.5/_box2D.scale));
					vertices.push(new V2(24.5/_box2D.scale, 223.5/_box2D.scale));
					vertices.push(new V2(18.5/_box2D.scale, 199.5/_box2D.scale));
					vertices.push(new V2(74.5/_box2D.scale, 92.5/_box2D.scale));
					vertices.push(new V2(96.5/_box2D.scale, 56.5/_box2D.scale));
					vertices.push(new V2(101.5/_box2D.scale, 56.5/_box2D.scale));
					vertices.push(new V2(113.5/_box2D.scale, 61.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(26.5/_box2D.scale, 251.5/_box2D.scale));
					vertices.push(new V2(24.5/_box2D.scale, 223.5/_box2D.scale));
					vertices.push(new V2(180.5/_box2D.scale, 202.5/_box2D.scale));
					vertices.push(new V2(174.5/_box2D.scale, 226.5/_box2D.scale));
					vertices.push(new V2(122.5/_box2D.scale, 283.5/_box2D.scale));
					vertices.push(new V2(72.5/_box2D.scale, 280.5/_box2D.scale));
					vertices.push(new V2(48.5/_box2D.scale, 273.5/_box2D.scale));
					vertices.push(new V2(32.5/_box2D.scale, 264.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(156.5/_box2D.scale, 273.5/_box2D.scale));
					vertices.push(new V2(122.5/_box2D.scale, 283.5/_box2D.scale));
					vertices.push(new V2(174.5/_box2D.scale, 226.5/_box2D.scale));
					vertices.push(new V2(172.5/_box2D.scale, 254.5/_box2D.scale));
					vertices.push(new V2(168.5/_box2D.scale, 264.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(76.5/_box2D.scale, 66.5/_box2D.scale));
					vertices.push(new V2(82.5/_box2D.scale, 60.5/_box2D.scale));
					vertices.push(new V2(96.5/_box2D.scale, 56.5/_box2D.scale));
					vertices.push(new V2(74.5/_box2D.scale, 92.5/_box2D.scale));
					vertices.push(new V2(72.5/_box2D.scale, 76.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(101.5/_box2D.scale, 34.5/_box2D.scale));
					vertices.push(new V2(97.5/_box2D.scale, 32.5/_box2D.scale));
					vertices.push(new V2(92.5/_box2D.scale, 14.5/_box2D.scale));
					vertices.push(new V2(95.5/_box2D.scale, 8.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(23.5/_box2D.scale, 117.5/_box2D.scale));
					vertices.push(new V2(34.5/_box2D.scale, 107.5/_box2D.scale));
					vertices.push(new V2(54.5/_box2D.scale, 97.5/_box2D.scale));
					vertices.push(new V2(74.5/_box2D.scale, 92.5/_box2D.scale));
					vertices.push(new V2(18.5/_box2D.scale, 199.5/_box2D.scale));
					vertices.push(new V2(9.5/_box2D.scale, 175.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(180.5/_box2D.scale, 202.5/_box2D.scale));
					vertices.push(new V2(24.5/_box2D.scale, 223.5/_box2D.scale));
					vertices.push(new V2(120.5/_box2D.scale, 91.5/_box2D.scale));
					vertices.push(new V2(154.5/_box2D.scale, 100.5/_box2D.scale));
					vertices.push(new V2(175.5/_box2D.scale, 114.5/_box2D.scale));
					vertices.push(new V2(188.5/_box2D.scale, 128.5/_box2D.scale));
					vertices.push(new V2(195.5/_box2D.scale, 166.5/_box2D.scale));
					
					_tab.push(vertices);
					vertices = new Vector.<V2>();
											
			        vertices.push(new V2(101.5/_box2D.scale, 34.5/_box2D.scale));
					vertices.push(new V2(101.5/_box2D.scale, 56.5/_box2D.scale));
					vertices.push(new V2(96.5/_box2D.scale, 56.5/_box2D.scale));
					vertices.push(new V2(97.5/_box2D.scale, 32.5/_box2D.scale));
					
					_tab.push(vertices);
					
					break;
			
			}
		}

		protected function _getDensity():Number {

			switch (peObject) {
				
				case "icecream":
					return 1;
					break;
			
				case "muffin":
					return 1;
					break;
			
			}

			return 1;
		}
		
		protected function _getFriction():Number {
			
			switch (peObject) {
				
				case "icecream":
					return 0.6;
					break;
			
				case "muffin":
					return 0.6;
					break;
			
			}

			return 0.6;
		}
		
		protected function _getRestitution():Number {
			
			switch (peObject) {
				
				case "icecream":
					return 0.3;
					break;
			
				case "muffin":
					return 0.3;
					break;
			
			}

			return 0.3;
		}
	}
}
